SystemOrganization addCategory: #'TADP-TP1'!
SystemOrganization addCategory: #'TADP-TP1-Tests'!

Trait named: #Actividad
	uses: {}
	category: 'TADP-TP1'!

!Actividad methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:39'!
esArticulo 
self requirement! !

!Actividad methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:33'!
estadoDeAprobacion 
self requirement! !

!Actividad methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:33'!
pendienteDeAprobacion 
^self estadoDeAprobacion! !

Trait named: #Estadistica
	uses: {}
	category: 'TADP-TP1'!

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:40'!
cantidadAbandonadas
^(self getMaterias select: [:materia | materia abandonada]) size 

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 17:20'!
cantidadAprobadas
^( self getMaterias select: [:materia | materia aprobada] ) size

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:54'!
cantidadAprobadasSobreCursadas

^((self getMaterias select: [:materia | materia aprobada]) size )/ ((self getMaterias select: [:materia | materia cursada]) size)

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 16:46'!
cantidadDesaprobadas
^(self getMaterias select: [:materia | materia not aprobada] size )

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/6/2013 09:53'!
getMaterias
	self requirement! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:45'!
listadoDeNotas
|col materias | 
col := Array  new:10.

materias := ((self getMaterias select: [ :materia | materia terminada]) collect: [:mat | mat nota]).


col at: 1 put: (materias occurrencesOf: 1).
col at:2 put: (materias occurrencesOf: 2).
col at:3 put:(materias occurrencesOf: 3).
col at:4 put:(materias occurrencesOf: 4).
col at:5 put:(materias occurrencesOf: 5).
col at:6 put:(materias occurrencesOf: 6).
col at:7 put:(materias occurrencesOf: 7).
col at:8 put: (materias occurrencesOf: 8).
col at:9 put:(materias occurrencesOf: 9).
col at:10 put:(materias occurrencesOf: 10).


^col! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 16:08'!
notaMasAlta: nVeces

|index listaInversa acum|
listaInversa := (self listadoDeNotas) reverse.
acum := nVeces.
index := 10.
listaInversa do: [:nota | nota >= acum ifTrue: [^index ] ifFalse:[acum := acum - nota. index := index -1] ].

"(11 - (listaInversa indexOf: nota))"! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 14:57'!
promedioConAplazos
|sumatoria|
sumatoria:= 0.
self getMaterias do: [:materia | sumatoria := sumatoria + materia nota ].

^(sumatoria / (self getMaterias size)).! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:51'!
promedioSinAplazos
|sumatoria|
sumatoria:= 0.
(self getMaterias select: [:materia | materia aprobada]) do: [:materiaAprobada | sumatoria := sumatoria + materiaAprobada  nota ].
^(sumatoria / (self getMaterias ;cantidadAprobadas) ).! !

Trait named: #Home
	uses: {}
	category: 'TADP-TP1'!

!Home classSide methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:27'!
newConHome: unHome
	^self new
		home: unHome;
		yourself.! !

Trait named: #Investigador
	uses: {}
	category: 'TADP-TP1'!

!Investigador methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 11:56'!
listadoDeEventos
^self gruposDeInvestigacion  ! !

TestCase subclass: #TP1Tests
	instanceVariableNames: 'estudiante carrera alumnoPerez cursoHistoria home historia profesorGarcia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1-Tests'!

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:50'!
setUp 
	home:= HomeMaterias new.
	alumnoPerez := Alumno newConHome: home .
	historia := Materia newConHome: home .
	profesorGarcia:= Docente new.
	cursoHistoria := Curso  newConHome: home .
	carrera := Carrera new.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:57'!
testAlumnoCantidadAbandonadas
	|alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso  newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0 yAlumno: alumnoPerez yMateria: historia ).
	self assert: alumnoPerez cantidadAbandonadas equals: 2.
	self assert: alumnoRodriguez  cantidadAbandonadas equals: 1.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:05'!
testAlumnoCantidadAprobadas
	|alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso  newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0 yAlumno: alumnoPerez yMateria: historia ).
	self assert: alumnoPerez cantidadAprobadasSobreCursadas  equals: (3/5).
	self assert: alumnoRodriguez  cantidadAprobadasSobreCursadas   equals: (1/2).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:58'!
testAlumnoListado
|col|
col := Array new: 10.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	
col at: 1 put: 0.
col at: 2 put: 2.
col at: 3 put: 0.
col at: 4 put: 0.
col at: 5 put: 0.
col at: 6 put: 0.
col at: 7 put: 0.
col at: 8 put: 2.
col at: 9 put: 0.
col at: 10 put: 0.
	self assert: alumnoPerez listadoDeNotas  equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 16:03'!
testAlumnoNotaMasAltaNVeces
|resultado1 resultado2 resultado3|
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	resultado1  := alumnoPerez notaMasAlta: 4.
 	resultado2 := alumnoPerez notaMasAlta: 6.
	resultado3 := alumnoPerez notaMasAlta: 8.
	self assert: 10 equals: resultado1.		
	self assert: 8 equals: resultado2.
	self assert: 2 equals: resultado3.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:56'!
testAlumnoPromedioConAplazos

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
self assert: alumnoPerez promedioConAplazos equals: 4.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:56'!
testAlumnoPromedioSinAplazos

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
self assert: 8 equals: alumnoPerez promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:20'!
testCarreraCantidadAbandonadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 2 equals: carrera cantidadAbandonadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:19'!
testCarreraCantidadAprobadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 4 equals: carrera cantidadAprobadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:55'!
testCarreraListado
|alumnoRodriguez col|
col := Array new: 10.

alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	carrera addAlumno: alumnoPerez.

	col at: 1 put: 0.	
	col at: 2 put: 1.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 2.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: carrera listadoDeNotas equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 16:16'!
testCarreraNotaMasAltaNVeces
|resultado1 resultado2 resultado3 resultado4 alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	carrera addAlumno: alumnoRodriguez.
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	carrera addAlumno: alumnoPerez.
	
	resultado1 := carrera notaMasAlta: 2.
 	resultado2 := carrera notaMasAlta: 4.
	resultado3 := carrera notaMasAlta: 6.
	resultado4 := carrera notaMasAlta: 7.
	self assert: 10 equals: resultado1.		
	self assert: 8 equals: resultado2.
	self assert: 7 equals: resultado3.
	self assert: 2 equals: resultado4.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:16'!
testCarreraPromedioConAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 5 equals: carrera promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:01'!
testCarreraPromedioSinAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 7  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 6 equals: carrera promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:53'!
testCursoCantidadAbandonadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 2 equals: cursoHistoria cantidadAbandonadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:54'!
testCursoCantidadAprobadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 4 equals: cursoHistoria cantidadAprobadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:55'!
testCursoListado
|alumnoRodriguez col|
col := Array new: 10.

alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	col at: 1 put: 0.	
	col at: 2 put: 1.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 2.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: cursoHistoria listadoDeNotas equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:57'!
testCursoNotaMasAltaNVeces
|resultado1 resultado2 resultado3 resultado4 alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	
	resultado1 := cursoHistoria notaMasAlta: 2.
 	resultado2 := cursoHistoria notaMasAlta: 4.
	resultado3 := cursoHistoria notaMasAlta: 6.
	resultado4 := cursoHistoria notaMasAlta: 7.
	self assert: 10 equals: resultado1.		
	self assert: 8 equals: resultado2.
	self assert: 7 equals: resultado3.
	self assert: 2 equals: resultado4.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:26'!
testCursoPromedioConAplazos
|alumnoRodriguez|
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 5 equals: cursoHistoria promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:51'!
testCursoPromedioSinAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).

self assert: 6 equals: cursoHistoria promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:23'!
testDocenteCantidadAbandonadas
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.

	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).


	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 2 equals: profesorGarcia cantidadAbandonadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:26'!
testDocenteCantidadAprobadas
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 4 equals: profesorGarcia cantidadAprobadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:31'!
testDocenteListado
|alumnoRodriguez col cursoProba|
col := Array new: 10.

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	col at: 1 put: 0.	
	col at: 2 put: 1.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 2.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: profesorGarcia listadoDeNotas equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:34'!
testDocenteNotaMasAltaNVeces
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	
	self assert: 10 equals: (profesorGarcia notaMasAlta: 2).
	self assert: 8 equals: (profesorGarcia notaMasAlta: 4).
	self assert: 7 equals: (profesorGarcia notaMasAlta: 6).
	self assert: 2 equals: (profesorGarcia notaMasAlta: 7).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:27'!
testDocentePromedioConAplazos
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 5 equals: profesorGarcia promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:29'!
testDocentePromedioSinAplazos
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
	alumnoRodriguez := Alumno newConHome:  home.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).

self assert: 6 equals: profesorGarcia promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:25'!
testMateriaCantidadAbandonadas
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 2 equals: historia cantidadAbandonadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:27'!
testMateriaCantidadAprobadas
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 4 equals: historia cantidadAprobadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:29'!
testMateriaListado
|alumnoRodriguez col cursoHistoria2|
col := Array new: 10.

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	col at: 1 put: 0.	
	col at: 2 put: 1.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 2.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: historia listadoDeNotas equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:30'!
testMateriaNotaMasAltaNVeces
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	
	self assert: 10 equals: (historia notaMasAlta: 2).
	self assert: 8 equals: (historia notaMasAlta: 4).
	self assert: 7 equals: (historia notaMasAlta: 6).
	self assert: 2 equals: (historia notaMasAlta: 7).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:27'!
testMateriaPromedioConAplazos
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 5 equals: historia promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:28'!
testMateriaPromedioSinAplazos
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).

self assert: 6 equals: historia promedioSinAplazos.! !

Object subclass: #Alumno
	uses: Estadistica + Home + Investigador
	instanceVariableNames: 'home gruposDeInvestigacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Alumno class
	uses: Estadistica classTrait + Home classTrait + Investigador classTrait
	instanceVariableNames: ''!

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:24'!
getMaterias
	^(home getMateriasDeAlumno: self)! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:24'!
home
^ home! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home: unHome 
home:= unHome ! !

Object subclass: #Aula
	instanceVariableNames: 'recursos capacidad pizarron'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!Aula methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:05'!
addRecursos: un
recursos add: un ! !

!Aula methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:04'!
capacidad
^capacidad! !

!Aula methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:05'!
capacidad: int
capacidad:= int! !

!Aula methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:04'!
pizarron 
^pizarron ! !

!Aula methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:04'!
pizarron: tamanio
pizarron := tamanio! !

!Aula methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:05'!
recursos 
^recursos ! !

Object subclass: #Carrera
	uses: Estadistica
	instanceVariableNames: 'alumnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Carrera class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Carrera methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:21'!
addAlumno: unAlumno 
	alumnos  add: unAlumno  ! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:20'!
alumnos 
^alumnos ! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:50'!
getMaterias
|col|
col := Bag new.
(self alumnos do: [:alumno | col addAll: alumno getMaterias ]).
^col! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 17:29'!
initialize
alumnos := Set new.! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:07'!
viejoMaterias
	^(self alumnos collect: [:alumno | alumno getMaterias ])! !

Object subclass: #Charla
	uses: Actividad
	instanceVariableNames: 'estadoDeAprobacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Charla class
	uses: Actividad classTrait
	instanceVariableNames: ''!

!Charla methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:39'!
esArticulo 
^false! !

!Charla methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:35'!
estadoDeAprobacion 
^estadoDeAprobacion! !

!Charla methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:35'!
estadoDeAprobacion: est
estadoDeAprobacion:= est! !

Object subclass: #Curso
	uses: Estadistica + Home
	instanceVariableNames: 'anio cuatrimestre materia home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Curso class
	uses: Estadistica classTrait + Home classTrait
	instanceVariableNames: ''!

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:46'!
getMaterias
	^(home getMateriasDeCurso: self)! !

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home
^home! !

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home: unHome 
home:= unHome ! !

Object subclass: #Docente
	uses: Estadistica + Investigador
	instanceVariableNames: 'cursos gruposDeInvestigacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Docente class
	uses: Estadistica classTrait + Investigador classTrait
	instanceVariableNames: ''!

!Docente methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:07'!
addCurso: unCurso 
	cursos add: unCurso   ! !

!Docente methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:16'!
cursos
^cursos! !

!Docente methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:16'!
cursos: listaCursos
cursos := listaCursos ! !

!Docente methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:22'!
getMaterias
	|col|
	col := Bag new.
	(self cursos do: [:curso | col addAll: curso getMaterias ]).
	^col! !

!Docente methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:07'!
initialize 
	cursos := Set new.  ! !

Object subclass: #Grupo
	instanceVariableNames: 'actividades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!Grupo methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 11:57'!
actividades
^actividades ! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:38'!
actividadesPendientesDeAprobacion
 ^self actividades select:[:act | act pendienteDeAprobacion] ! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:06'!
addActividad: act
actividades add: act! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:39'!
articulosPublicados
^self actividades select:[:act | act esArticulo]! !

Object subclass: #HomeMaterias
	instanceVariableNames: 'materiasCursadas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:23'!
addMateriaCursada: unaMateria
materiasCursadas add: unaMateria ! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:17'!
getMateriasDeAlumno: unAlumno
^(self materiasCursadas select: [:materia | materia  alumno  = unAlumno ])! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:20'!
getMateriasDeCurso: unCurso
^(self materiasCursadas select: [:materia | materia curso  = unCurso])! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:20'!
getMateriasDeMateria: unaMateria
^(self materiasCursadas select: [:materia | materia  materia  = unaMateria ])! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/11/2013 10:33'!
initialize 
materiasCursadas := Bag new.
! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/11/2013 09:44'!
materiasCursadas
^materiasCursadas! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/11/2013 09:44'!
materiasCursadas: materia
materiasCursadas:= materia  ! !

Object subclass: #Materia
	uses: Estadistica + Home
	instanceVariableNames: 'home cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Materia class
	uses: Estadistica classTrait + Home classTrait
	instanceVariableNames: ''!

!Materia methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:17'!
addCurso: unCurso 
	cursos add: unCurso   ! !

!Materia methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:17'!
cursos
^cursos! !

!Materia methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:17'!
cursos: listaCursos
cursos := listaCursos ! !

!Materia methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:16'!
getMaterias
	|col|
	col := Bag new.
	(self cursos do: [:curso | col addAll: curso getMaterias ]).
	^col! !

!Materia methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home
^home! !

!Materia methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home: unHome 
home:= unHome ! !

!Materia methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:18'!
initialize
cursos := Set new.! !

Object subclass: #MateriaAbstracta
	instanceVariableNames: 'nota curso alumno materia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

MateriaAbstracta subclass: #MateriaAbandonada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:35'!
abandonada 
^true! !

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:06'!
aprobada

^false! !

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:06'!
cursada
 ^true! !

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:34'!
terminada
^false! !

!MateriaAbstracta class methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:11'!
newConCurso: unCurso yNota: unaNota yAlumno: unAlumno  yMateria: unaMateria 
^self new
nota: unaNota;
curso: unCurso;
materia:  unaMateria ;
alumno: unAlumno ;
yourself.! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:21'!
abandonada
^ self subclassResponsibility! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
alumno
^alumno ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:09'!
alumno: unAlumno
alumno := unAlumno ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
curso
^curso ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
curso:unaNota
curso:=  unaNota ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
materia 
^materia ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
materia: unaMateria
materia := unaMateria ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
nota
^ nota! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
nota:unaNota
nota:=  unaNota ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:34'!
terminada
^ self subclassResponsibility! !

MateriaAbstracta subclass: #MateriaEnCurso
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:36'!
abandonada
^false! !

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
aprobada 
^false! !

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
cursada
^false! !

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:34'!
terminada
^false! !

MateriaAbstracta subclass: #MateriaFirmada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:36'!
abandonada
^false! !

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:09'!
aprobada
^nota>3! !

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:10'!
cursada
^true! !

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:35'!
terminada
^true! !

Object subclass: #Proyecto
	uses: Actividad
	instanceVariableNames: 'estadoDeAprobacion resultado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Proyecto class
	uses: Actividad classTrait
	instanceVariableNames: ''!

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:42'!
addResultado: res
resultado add: res! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:41'!
esArticulo 
^resultado esArticulo ! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:20'!
estadoDeAprobacion 
^estadoDeAprobacion ! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:20'!
estadoDeAprobacion: estado
estadoDeAprobacion:= estado  ! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:40'!
resultado 
^resultado ! !

Object subclass: #Seminario
	uses: Actividad
	instanceVariableNames: 'estadoDeAprobacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Seminario class
	uses: Actividad classTrait
	instanceVariableNames: ''!

!Seminario methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:39'!
esArticulo 
^false! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:21'!
estadoDeAprobacion
^estadoDeAprobacion ! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:21'!
estadoDeAprobacion: est
estadoDeAprobacion := est! !
